/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.UnidentifiedSongDsrRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class UnidentifiedSongDsr extends TableImpl<UnidentifiedSongDsrRecord> {

    private static final long serialVersionUID = -1203212006;

    /**
     * The reference instance of <code>unidentified_song_dsr</code>
     */
    public static final UnidentifiedSongDsr UNIDENTIFIED_SONG_DSR = new UnidentifiedSongDsr();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<UnidentifiedSongDsrRecord> getRecordType() {
        return UnidentifiedSongDsrRecord.class;
    }

    /**
     * The column <code>unidentified_song_dsr.id_util</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, String> ID_UTIL = createField("id_util", org.jooq.impl.SQLDataType.VARCHAR(255).nullable(false), this, "");

    /**
     * The column <code>unidentified_song_dsr.hash_id</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, String> HASH_ID = createField("hash_id", org.jooq.impl.SQLDataType.CHAR(40).nullable(false), this, "");

    /**
     * The column <code>unidentified_song_dsr.id_dsr</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, String> ID_DSR = createField("id_dsr", org.jooq.impl.SQLDataType.VARCHAR(512), this, "");

    /**
     * The column <code>unidentified_song_dsr.album_title</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, String> ALBUM_TITLE = createField("album_title", org.jooq.impl.SQLDataType.VARCHAR(4095), this, "");

    /**
     * The column <code>unidentified_song_dsr.proprietary_id</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, String> PROPRIETARY_ID = createField("proprietary_id", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>unidentified_song_dsr.isrc</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, String> ISRC = createField("isrc", org.jooq.impl.SQLDataType.CHAR(12), this, "");

    /**
     * The column <code>unidentified_song_dsr.iswc</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, String> ISWC = createField("iswc", org.jooq.impl.SQLDataType.CHAR(11), this, "");

    /**
     * The column <code>unidentified_song_dsr.sales_count</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, Long> SALES_COUNT = createField("sales_count", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaultValue(org.jooq.impl.DSL.inline("0", org.jooq.impl.SQLDataType.BIGINT)), this, "");

    /**
     * The column <code>unidentified_song_dsr.dsp</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, String> DSP = createField("dsp", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>unidentified_song_dsr.insert_time</code>.
     */
    public final TableField<UnidentifiedSongDsrRecord, Long> INSERT_TIME = createField("insert_time", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

    /**
     * Create a <code>unidentified_song_dsr</code> table reference
     */
    public UnidentifiedSongDsr() {
        this(DSL.name("unidentified_song_dsr"), null);
    }

    /**
     * Create an aliased <code>unidentified_song_dsr</code> table reference
     */
    public UnidentifiedSongDsr(String alias) {
        this(DSL.name(alias), UNIDENTIFIED_SONG_DSR);
    }

    /**
     * Create an aliased <code>unidentified_song_dsr</code> table reference
     */
    public UnidentifiedSongDsr(Name alias) {
        this(alias, UNIDENTIFIED_SONG_DSR);
    }

    private UnidentifiedSongDsr(Name alias, Table<UnidentifiedSongDsrRecord> aliased) {
        this(alias, aliased, null);
    }

    private UnidentifiedSongDsr(Name alias, Table<UnidentifiedSongDsrRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> UnidentifiedSongDsr(Table<O> child, ForeignKey<O, UnidentifiedSongDsrRecord> key) {
        super(child, key, UNIDENTIFIED_SONG_DSR);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.UNIDENTIFIED_SONG_DSR_PRIMARY, Indexes.UNIDENTIFIED_SONG_DSR_UNIDENTIFIED_SONG_DSR_IDX_01, Indexes.UNIDENTIFIED_SONG_DSR_UNIDENTIFIED_SONG_DSR_IDX_02);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<UnidentifiedSongDsrRecord> getPrimaryKey() {
        return Keys.KEY_UNIDENTIFIED_SONG_DSR_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<UnidentifiedSongDsrRecord>> getKeys() {
        return Arrays.<UniqueKey<UnidentifiedSongDsrRecord>>asList(Keys.KEY_UNIDENTIFIED_SONG_DSR_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UnidentifiedSongDsr as(String alias) {
        return new UnidentifiedSongDsr(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UnidentifiedSongDsr as(Name alias) {
        return new UnidentifiedSongDsr(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public UnidentifiedSongDsr rename(String name) {
        return new UnidentifiedSongDsr(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public UnidentifiedSongDsr rename(Name name) {
        return new UnidentifiedSongDsr(name, null);
    }
}
